#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define int long long

const int inf = 1e18;

using namespace std;

void solve() {
    int n, k;

    cin >> n >> k;

    vector<int> a(n);

    for (int& i : a) cin >> i;

    // vector<vector<pair<int, int>>> dp(n, vector<pair<int, int>> (k, {inf, -inf}));
    //
    // for (int i = 0; i < n; i++) {
    //     for (int j = 1; j < k; j++) {
    //         for (int k1 = 0; k1 <= i; k1++) {
    //             int sm = 0;
    //
    //             for (int k2 = i; k2 <= k1; k2++) {
    //                 sm += a[k2];
    //             }
    //
    //             dp[i][j].second = max({dp[i][j].second, sm, dp[k1][j - 1].second});
    //             dp[i][j].first = min({dp[i][j].first, sm, dp[k1][j - 1].first});
    //         }
    //     }
    // }
    //
    // int d = 0;
    //
    // for (int i = 0; i < k; i++) {
    //     d = max(d, dp[n - 1][i].second - dp[n - 1][i].first);
    // }
    //
    // cout << d << '\n';

    vector<vector<pair<int, int>>> dp(n + 1, vector<pair<int, int>> (k + 1, {-inf, inf}));

    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= min(k, i); j++) {
            if (j == 1) {
                dp[i][j] = dp[i - 1][j];
                dp[i][j].first += a[i - 1];
                dp[i][j].second += a[i - 1];
            } else if (i != 1) {
                dp[i][j] = dp[i - 1][j];
                dp[i][j].second += a[i - 1];

                if (dp[i][j].second - dp[i][j].first < dp[i][j].second - a[i - 1] - min(a[i - 1], dp[i][j].first)) {
                    dp[i][j].first = a[i - 1];
                    dp[i][j].second -= a[i - 1];
                }
            }
        }
    }

    cout << dp[n][k].second - dp[n][k].first << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;

    // cin >> t;

    // for (int i = 1; i <= 100; i++) {
    //     cout << i << ' ';
    //     solve(i);
    // }

     while (t--) {
         solve();
     }
}