#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define int long long

const int inf = 1e18;

using namespace std;

void solve() {
    int n, s;

    cin >> n >> s;

    vector<vector<int>> c(n);

    for (int i = 0; i < n; i++) {
        int k;

        cin >> k;

        while (k--) {
            int x;

            cin >> x;

            c[i].push_back(x);
        }
    }

    if (n == 1) {
        vector<vector<int>> dp(c[0].size() + 1, vector<int> (s + 1, -1));
        dp[0][0] = 0;
        set<int> st;

        for (int i = 1; i <= c[0].size(); i++) {
            for (int j = 1; j <= s; j++) {
                dp[i][j] = dp[i - 1][j];
                dp[i][0] = 0;

                if (j - c[0][i - 1] >= 0) {
                    if (dp[i - 1][j - c[0][i - 1]] != -1) {
                        dp[i][j] = i;
                    }
                }
            }
        }

        if (dp[c[0].size()][s] == -1) {
            cout << "No\n";
        } else {
            cout << "Yes\n";
            int i = c[0].size();
            int j = s;

            while (j != 0) {
                st.insert(dp[i][j]);
                j = j - c[0][dp[i][j] - 1];
                i--;
            }

            cout << st.size() << "\n";
            for (auto& i : st) cout << i << " ";
            cout << "\n";
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;

    // cin >> t;

    while (t--) {
        solve();
    }
}