#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define int long long

const int inf = 1e18;

using namespace std;

void solve() {
    int n, k;

    cin >> n >> k;

    if (k == 1) {
        cout << "0\n";
        return;
    }

    vector<int> a(n);

    for (int& i : a) cin >> i;

    int d = 0;
    vector<int> p(n + 1);

    for (int i = 1; i <= n; i++) {
        p[i] = p[i - 1] + a[i - 1];
    }

    vector<int> pref(n);
    pref[0] = a[0];

    vector<int> suff(n);
    suff[n - 1] = a[n - 1];

    for (int i = 1; i < n; i++) {
        pref[i] = min(pref[i - 1], a[i]);
    }

    for (int i = n - 2; i >= 0; i--) {
        suff[i] = min(suff[i + 1], a[i]);
    }

    if (k == 2) {
        for (int i = 0; i < n - 1; i++) {
            int p1 = p[i + 1] - p[0];
            int p2 = p[n] - p[i + 1];

            d = max(d, max(p1, p2) - min(p1, p2));
        }

        cout << d << "\n";
        return;
    }

    for (int l1 = 0; l1 < n; l1++) {
        for (int r1 = l1; r1 < n; r1++) {
            int len1 = r1 - l1 + 1;

            if (n - len1 < k - 1) {
                continue;
            }

            if (l1 != 0) {
                int sm1 = p[r1 + 1] - p[l1];
                int sm2 = pref[l1 - 1];
                d = max(d, max(sm1, sm2) - min(sm1, sm2));
            }

            if (r1 != n - 1) {
                int sm1 = p[r1 + 1] - p[l1];
                int sm2 = suff[r1 + 1];
                d = max(d, max(sm1, sm2) - min(sm1, sm2));
            }
        }
    }

    cout << d << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;

    // cin >> t;

    // for (int i = 1; i <= 100; i++) {
    //     cout << i << ' ';
    //     solve(i);
    // }

     while (t--) {
         solve();
     }
}