#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define int long long

const int inf = 1e18;

using namespace std;

void solve() {
    int n, s;

    cin >> n >> s;

    vector<vector<int>> c(n);
    vector<int> a(n);

    for (int i = 0; i < n; i++) {
        int k;

        cin >> k;

        while (k--) {
            int x;

            cin >> x;

            c[i].push_back(x);
            a[i] = x;
        }
    }

    vector<vector<int>> dp(n + 1, vector<int> (s + 1, -1));
    dp[0][0] = -2;

    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= s; j++) {
            dp[i][j] = dp[i - 1][j];

            if (j - a[i - 1] >= 0 && dp[i - 1][j - a[i - 1]] != -1) {
                dp[i][j] = i;
            }
        }
    }

    if (dp[n][s] == -1) {
        cout << "No\n";
    } else {
        set<int> st;
        int i = n;
        int j = s;

        while (dp[i][j] != -2) {
            st.insert(dp[i][j]);
            j = j - a[dp[i][j] - 1];
            i--;
        }

        cout << "Yes\n";
        cout << st.size() << "\n";
        for (auto& i : st) cout << i << ' ';
        cout << "\n";
    }

    // if (n == 1) {
    //     n = c[0].size();
    //     vector<vector<int>> dp(n + 1, vector<int> (s + 1, -1));
    //     dp[0][0] = -2;
    //
    //     for (int i = 1; i <= n; i++) {
    //         for (int j = 1; j <= s; j++) {
    //             dp[i][j] = dp[i - 1][j];
    //
    //             if (j - c[0][i - 1] >= 0 && dp[i - 1][j - c[0][i - 1]] != -1) {
    //                 dp[i][j] = i;
    //             }
    //         }
    //     }
    //
    //     if (dp[n][s] == -1) {
    //         cout << "No\n";
    //     } else {
    //         set<int> st;
    //         int i = n;
    //         int j = s;
    //
    //         while (dp[i][j] != -2) {
    //             st.insert(dp[i][j]);
    //             j = j - c[0][i - 1];
    //             i--;
    //         }
    //
    //         cout << "Yes\n";
    //         cout << st.size() << "\n";
    //         for (auto& i : st) cout << i << ' ';
    //         cout << "\n";
    //     }
    // }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;

    // cin >> t;

    while (t--) {
        solve();
    }
}