#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define int long long

const int inf = 1e18;
const int W = 1e5 + 10;

using namespace std;

struct e {
    int i, j, x;
};

void solve() {
    int n, s;

    cin >> n >> s;

    vector<vector<int>> c(n);
    vector<e> a;

    for (int i = 0; i < n; i++) {
        int k;

        cin >> k;

        for (int j = 0; j < k; j++) {
            int x;

            cin >> x;

            c[i].push_back(x);
            a.push_back({i, j, x});
        }
    }

    if (n == 1) {
        vector<vector<int>> dp(c[0].size() + 1, vector<int> (s + 1, -1));
        dp[0][0] = 0;
        set<int> st;

        for (int i = 1; i <= c[0].size(); i++) {
            for (int j = 1; j <= s; j++) {
                dp[i][j] = dp[i - 1][j];
                dp[i][0] = 0;

                if (j - c[0][i - 1] >= 0) {
                    if (dp[i - 1][j - c[0][i - 1]] != -1) {
                        dp[i][j] = i;
                    }
                }
            }
        }

        if (dp[c[0].size()][s] == -1) {
            cout << "No\n";
        } else {
            cout << "Yes\n";
            int i = c[0].size();
            int j = s;

            while (j != 0) {
                st.insert(dp[i][j]);
                j = j - c[0][dp[i][j] - 1];
                i--;
            }

            cout << st.size() << "\n";
            for (auto& i : st) cout << i << " ";
            cout << "\n";
        }
    } else {
        for (int mask = 0; mask < (1 << a.size()); mask++) {
            vector<pair<int, int>> sm;
            int sum = 0;
            vector<int> p(n);

            for (int i = 0; i < a.size(); i++) {
                if (mask >> i & 1) {
                    sm.push_back({a[i].i, a[i].j});
                    sum += a[i].x;
                    p[a[i].i] = 1;
                }
            }

            int y = 1;

            for (int i = 0; i < n; i++) {
                if (!p[i]) {
                    y = 0;
                    break;
                }
            }

            if (!y) {
                continue;
            }

            if (sum != s) {
            } else {
                map<int, vector<int>> mp;

                for (int i = 0; i < sm.size(); i++) {
                    mp[sm[i].first].push_back(sm[i].second);
                }

                cout << "Yes\n";
                vector<vector<int>> res;

                for (auto& i : mp) {
                    res.push_back(i.second);
                }

                for (int i = 0; i < n; i++) {
                    cout << res[i].size() << "\n";
                    for (auto& j : res[i]) {
                        cout << j + 1 << " ";
                    }

                    cout << "\n";
                }

                return;
            }
        }

        cout << "No\n";
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;

    // cin >> t;

    while (t--) {
        solve();
    }
}