#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define int long long

const int inf = 1e18;
const int W = 1e5 + 10;

using namespace std;

vector<pair<int, int>> a;
int ans = 0;
int k;
int n, m;

void rec(int i, int j, int len, set<pair<int, int>> st, int yes) {
    if (i >= n || j >= m) {
        return;
    }

    if (len > 2 * n + 2 * m - 4) {
        return;
    }

    if (len == 2 * n + 2 * m - 4) {
        if (i == 0 && j == 0 && st.size() == k && yes) {
            ans++;
        }

        return;
    }

    for (auto& tmp : a) {
        if (st.count({min(i, j), max(i, j)})) {
            return;
        }

        if (tmp.first - 1 == i && tmp.second - 1 == j) {
            st.insert({min(i, j), max(i, j)});
        }
    }

    if (yes || (i == n - 1 && j == m - 1)) {
        rec(i - 1, j, len + 1, st, 1);
        rec(i, j - 1, len + 1, st, 1);
    } else {
        rec(i + 1, j, len + 1, st, 0);
        rec(i, j + 1, len + 1, st, 0);
    }

    return;
}

void solve() {
    cin >> n >> m >> k;

    a.resize(k);
    for (auto& i : a) cin >> i.first >> i.second;

    rec(0, 0, 0, {}, 0);

    cout << ans << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;

    // cin >> t;

    while (t--) {
        solve();
    }
}